/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.62 Revision 1.121
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2008 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.62 2004/07/15 04:59:44 lv Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.121 2008/02/16 22:43:04 vapier Exp $
4
5# @ECLASS: flag-o-matic.eclass
6# @MAINTAINER:
7# toolchain@gentoo.org
8# @BLURB: common functions to manipulate and query toolchain flags
9# @DESCRIPTION:
10# This eclass contains a suite of functions to help developers sanely
11# and safely manage toolchain flags in their builds.
12
13inherit eutils toolchain-funcs multilib
14
15################ DEPRECATED functions ################
16# The following are still present to avoid breaking existing
17# code more than necessary; however they are deprecated. Please
18# use gcc-specs-* from toolchain-funcs.eclass instead, if you
19# need to know which hardened techs are active in the compiler.
20# See bug #100974
4# 21#
5# Author Bart Verwilst <verwilst@gentoo.org> 22# has_hardened
23# has_pie
24# has_pic
25# has_ssp_all
26# has_ssp
6 27
7ECLASS=flag-o-matic
8INHERITED="$INHERITED $ECLASS"
9IUSE="$IUSE debug"
10
11#
12#### filter-flags <flags> ####
13# Remove particular flags from C[XX]FLAGS
14# Matches only complete flags
15#
16#### append-flags <flags> ####
17# Add extra flags to your current C[XX]FLAGS
18#
19#### replace-flags <orig.flag> <new.flag> ###
20# Replace a flag by another one
21#
22#### replace-cpu-flags <new.cpu> <old.cpus> ###
23# Replace march/mcpu flags that specify <old.cpus>
24# with flags that specify <new.cpu>
25#
26#### is-flag <flag> ####
27# Returns "true" if flag is set in C[XX]FLAGS
28# Matches only complete a flag
29#
30#### strip-flags ####
31# Strip C[XX]FLAGS of everything except known
32# good options.
33#
34#### strip-unsupported-flags ####
35# Strip C[XX]FLAGS of any flags not supported by
36# installed version of gcc
37#
38#### get-flag <flag> ####
39# Find and echo the value for a particular flag
40#
41#### replace-sparc64-flags ####
42# Sets mcpu to v8 and uses the original value
43# as mtune if none specified.
44#
45#### filter-mfpmath <math types> ####
46# Remove specified math types from the fpmath specification
47# If the user has -mfpmath=sse,386, running `filter-mfpmath sse`
48# will leave the user with -mfpmath=386
49#
50#### append-ldflags ####
51# Add extra flags to your current LDFLAGS
52#
53#### filter-ldflags <flags> ####
54# Remove particular flags from LDFLAGS
55# Matches only complete flags
56#
57#### etexec-flags ####
58# hooked function for hardened gcc that appends
59# -fno-pic to {C,CXX,LD}FLAGS
60# when a package is filtering -fpic, -fPIC, -fpie, -fPIE
61#
62#### fstack-flags ####
63# hooked function for hardened gcc that appends
64# -fno-stack-protector to {C,CXX,LD}FLAGS
65# when a package is filtering -fstack-protector, -fstack-protector-all
66# notice: modern automatic specs files will also suppress -fstack-protector-all
67# when only -fno-stack-protector is given
68#
69 28
70# C[XX]FLAGS that we allow in strip-flags 29# C[XX]FLAGS that we allow in strip-flags
30# Note: shell globs and character lists are allowed
71setup-allowed-flags() { 31setup-allowed-flags() {
72 if [ -z "${ALLOWED_FLAGS}" ] ; then 32 if [[ -z ${ALLOWED_FLAGS} ]] ; then
73 export ALLOWED_FLAGS="-O -O1 -O2 -mcpu -march -mtune -fstack-protector -fno-unit-at-a-time -pipe -g" 33 export ALLOWED_FLAGS="-pipe"
74 case "${ARCH}" in 34 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
75 mips) ALLOWED_FLAGS="${ALLOWED_FLAGS} -mips1 -mips2 -mips3 -mips4 -mabi" ;; 35 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
76 amd64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC -m64" ;; 36 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking"
37 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
38 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
39 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
77 x86) ALLOWED_FLAGS="${ALLOWED_FLAGS} -m32" ;; 40 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -W* -w"
78 alpha) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;;
79 ia64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;;
80 esac
81 fi 41 fi
42 # allow a bunch of flags that negate features / control ABI
43 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \
44 -fno-strict-aliasing -fno-bounds-checking"
45 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
46 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
47 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
48 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
49 -mieee -mieee-with-inexact -mschedule \
50 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
51 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
52 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
53 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
54 -msecure-plt -D*"
82 55
83 # C[XX]FLAGS that we are think is ok, but needs testing 56 # C[XX]FLAGS that we are think is ok, but needs testing
84 # NOTE: currently -Os have issues with gcc3 and K6* arch's 57 # NOTE: currently -Os have issues with gcc3 and K6* arch's
85 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks -fprefetch-loop-arrays" 58 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
86 return 0 59 return 0
87} 60}
88 61
62# inverted filters for hardened compiler. This is trying to unpick
63# the hardened compiler defaults.
64_filter-hardened() {
65 local f
66 for f in "$@" ; do
67 case "${f}" in
68 # Ideally we should only concern ourselves with PIE flags,
69 # not -fPIC or -fpic, but too many places filter -fPIC without
70 # thinking about -fPIE.
71 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
72 gcc-specs-pie || continue
73 is-flagq -nopie || append-flags -nopie;;
74 -fstack-protector)
75 gcc-specs-ssp || continue
76 is-flagq -fno-stack-protector || append-flags -fno-stack-protector;;
77 -fstack-protector-all)
78 gcc-specs-ssp-to-all || continue
79 is-flagq -fno-stack-protector-all || append-flags -fno-stack-protector-all;;
80 esac
81 done
82}
83
84# Remove occurrences of strings from variable given in $1
85# Strings removed are matched as globs, so for example
86# '-O*' would remove -O1, -O2 etc.
87_filter-var() {
88 local f x VAR VAL
89 declare -a new
90
91 VAR=$1
92 shift
93 eval VAL=\${${VAR}}
94 for f in ${VAL}; do
95 for x in "$@"; do
96 # Note this should work with globs like -O*
97 [[ ${f} == ${x} ]] && continue 2
98 done
99 eval new\[\${\#new\[@]}]=\${f}
100 done
101 eval export ${VAR}=\${new\[*]}
102}
103
104# @FUNCTION: filter-flags
105# @USAGE: <flags>
106# @DESCRIPTION:
107# Remove particular <flags> from {C,CPP,CXX}FLAGS. Accepts shell globs.
89filter-flags() { 108filter-flags() {
90 local x f fset 109 _filter-hardened "$@"
91 declare -a new_CFLAGS new_CXXFLAGS 110 _filter-var CFLAGS "$@"
92 111 _filter-var CPPFLAGS "$@"
93 for x in "$@" ; do 112 _filter-var CXXFLAGS "$@"
94 case "${x}" in
95 -fPIC|-fpic|-fPIE|-fpie|-pie) etexec-flags;;
96 -fstack-protector|-fstack-protector-all) fstack-flags;;
97 esac
98 done
99
100 for fset in CFLAGS CXXFLAGS; do
101 for f in ${!fset}; do
102 for x in "$@"; do
103 # Note this should work with globs like -O*
104 [[ ${f} == ${x} ]] && continue 2
105 done
106 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
107 done
108 eval export ${fset}=\${new_${fset}\[*]}
109 done
110
111 return 0 113 return 0
112} 114}
113 115
116# @FUNCTION: filter-lfs-flags
117# @DESCRIPTION:
118# Remove flags that enable Large File Support.
114filter-lfs-flags() { 119filter-lfs-flags() {
120 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
115 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 121 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
116} 122}
117 123
124# @FUNCTION: append-cppflags
125# @USAGE: <flags>
126# @DESCRIPTION:
127# Add extra <flags> to the current CPPFLAGS.
128append-cppflags() {
129 [[ -z $* ]] && return 0
130 export CPPFLAGS="${CPPFLAGS} $*"
131 return 0
132}
133
134# @FUNCTION: append-lfs-flags
135# @DESCRIPTION:
136# Add flags that enable Large File Support.
118append-lfs-flags() { 137append-lfs-flags() {
138 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
119 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 139 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
120} 140}
121 141
142# @FUNCTION: append-flags
143# @USAGE: <flags>
144# @DESCRIPTION:
145# Add extra <flags> to your current C[XX]FLAGS.
122append-flags() { 146append-flags() {
147 [[ -z $* ]] && return 0
123 export CFLAGS="${CFLAGS} $*" 148 export CFLAGS="${CFLAGS} $*"
124 export CXXFLAGS="${CXXFLAGS} $*" 149 export CXXFLAGS="${CXXFLAGS} $*"
125 [ -n "`is-flag -fno-stack-protector`" -o \
126 -n "`is-flag -fno-stack-protector-all`" ] && fstack-flags
127 return 0 150 return 0
128} 151}
129 152
153# @FUNCTION: replace-flags
154# @USAGE: <old> <new>
155# @DESCRIPTION:
156# Replace the <old> flag with <new>. Accepts shell globs for <old>.
130replace-flags() { 157replace-flags() {
131 # we do this fancy spacing stuff so as to not filter 158 [[ $# != 2 ]] \
132 # out part of a flag ... we want flag atoms ! :D 159 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
133 CFLAGS=" ${CFLAGS} " 160 && die "replace-flags takes 2 arguments, not $#"
134 CXXFLAGS=" ${CXXFLAGS} "
135 CFLAGS="${CFLAGS// ${1} / ${2} }"
136 CXXFLAGS="${CXXFLAGS// ${1} / ${2} }"
137 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}"
138 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}"
139 export CFLAGS CXXFLAGS
140 return 0
141}
142 161
162 local f fset
163 declare -a new_CFLAGS new_CXXFLAGS
164
165 for fset in CFLAGS CXXFLAGS; do
166 # Looping over the flags instead of using a global
167 # substitution ensures that we're working with flag atoms.
168 # Otherwise globs like -O* have the potential to wipe out the
169 # list of flags.
170 for f in ${!fset}; do
171 # Note this should work with globs like -O*
172 [[ ${f} == ${1} ]] && f=${2}
173 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
174 done
175 eval export ${fset}=\${new_${fset}\[*]}
176 done
177
178 return 0
179}
180
181# @FUNCTION: replace-cpu-flags
182# @USAGE: <old> <new>
183# @DESCRIPTION:
184# Replace cpu flags (like -march/-mcpu/-mtune) that select the <old> cpu
185# with flags that select the <new> cpu. Accepts shell globs for <old>.
143replace-cpu-flags() { 186replace-cpu-flags() {
144 local oldcpu newcpu="$1" ; shift 187 local newcpu="$#" ; newcpu="${!newcpu}"
145 for oldcpu in "$@" ; do 188 while [ $# -gt 1 ] ; do
189 # quote to make sure that no globbing is done (particularly on
190 # ${oldcpu}) prior to calling replace-flags
146 replace-flags -march=${oldcpu} -march=${newcpu} 191 replace-flags "-march=${1}" "-march=${newcpu}"
147 replace-flags -mcpu=${oldcpu} -mcpu=${newcpu} 192 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
148 replace-flags -mtune=${oldcpu} -mtune=${newcpu} 193 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
194 shift
149 done 195 done
196 return 0
197}
198
199_is_flagq() {
200 local x
201 for x in ${!1} ; do
202 [[ ${x} == $2 ]] && return 0
203 done
150 return 0 204 return 1
151} 205}
152 206
207# @FUNCTION: is-flagq
208# @USAGE: <flag>
209# @DESCRIPTION:
210# Returns shell true if <flag> is in C[XX]FLAGS, else returns shell false. Accepts shell globs.
211is-flagq() {
212 [[ -n $2 ]] && die "Usage: is-flag <flag>"
213 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1
214}
215
216# @FUNCTION: is-flag
217# @USAGE: <flag>
218# @DESCRIPTION:
219# Echo's "true" if flag is set in C[XX]FLAGS. Accepts shell globs.
153is-flag() { 220is-flag() {
154 local x 221 is-flagq "$@" && echo true
155
156 for x in ${CFLAGS} ${CXXFLAGS} ; do
157 if [ "${x}" == "$1" ] ; then
158 echo true
159 return 0
160 fi
161 done
162 return 1
163} 222}
164 223
224# @FUNCTION: is-ldflagq
225# @USAGE: <flag>
226# @DESCRIPTION:
227# Returns shell true if <flag> is in LDFLAGS, else returns shell false. Accepts shell globs.
228is-ldflagq() {
229 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
230 _is_flagq LDFLAGS $1
231}
232
233# @FUNCTION: is-ldflag
234# @USAGE: <flag>
235# @DESCRIPTION:
236# Echo's "true" if flag is set in LDFLAGS. Accepts shell globs.
237is-ldflag() {
238 is-ldflagq "$@" && echo true
239}
240
241# @FUNCTION: filter-mfpmath
242# @USAGE: <math types>
243# @DESCRIPTION:
244# Remove specified math types from the fpmath flag. For example, if the user
245# has -mfpmath=sse,386, running `filter-mfpmath sse` will leave the user with
246# -mfpmath=386.
165filter-mfpmath() { 247filter-mfpmath() {
166 local orig_mfpmath new_math prune_math 248 local orig_mfpmath new_math prune_math
167 249
168 # save the original -mfpmath flag 250 # save the original -mfpmath flag
169 orig_mfpmath="`get-flag -mfpmath`" 251 orig_mfpmath=$(get-flag -mfpmath)
170 # get the value of the current -mfpmath flag 252 # get the value of the current -mfpmath flag
171 new_math=" `get-flag mfpmath | tr , ' '` " 253 new_math=$(get-flag mfpmath)
254 new_math=" ${new_math//,/ } "
172 # figure out which math values are to be removed 255 # figure out which math values are to be removed
173 prune_math="" 256 prune_math=""
174 for prune_math in "$@" ; do 257 for prune_math in "$@" ; do
175 new_math="${new_math/ ${prune_math} / }" 258 new_math=${new_math/ ${prune_math} / }
176 done 259 done
177 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`" 260 new_math=$(echo ${new_math})
261 new_math=${new_math// /,}
178 262
179 if [ -z "${new_math}" ] ; then 263 if [[ -z ${new_math} ]] ; then
180 # if we're removing all user specified math values are 264 # if we're removing all user specified math values are
181 # slated for removal, then we just filter the flag 265 # slated for removal, then we just filter the flag
182 filter-flags ${orig_mfpmath} 266 filter-flags ${orig_mfpmath}
183 else 267 else
184 # if we only want to filter some of the user specified 268 # if we only want to filter some of the user specified
186 replace-flags ${orig_mfpmath} -mfpmath=${new_math} 270 replace-flags ${orig_mfpmath} -mfpmath=${new_math}
187 fi 271 fi
188 return 0 272 return 0
189} 273}
190 274
275# @FUNCTION: strip-flags
276# @DESCRIPTION:
277# Strip C[XX]FLAGS of everything except known good/safe flags.
191strip-flags() { 278strip-flags() {
192 local x y flag NEW_CFLAGS NEW_CXXFLAGS 279 local x y flag NEW_CFLAGS NEW_CXXFLAGS
193 280
194 setup-allowed-flags 281 setup-allowed-flags
195 282
196 local NEW_CFLAGS="" 283 local NEW_CFLAGS=""
197 local NEW_CXXFLAGS="" 284 local NEW_CXXFLAGS=""
198 285
199 # Allow unstable C[XX]FLAGS if we are using unstable profile ... 286 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
200 if has ~${ARCH} ${ACCEPT_KEYWORDS} ; then 287 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
201 use debug && einfo "Enabling the use of some unstable flags"
202 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}" 288 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
203 fi 289 fi
204 290
205 set -f # disable pathname expansion 291 set -f # disable pathname expansion
206 292
207 for x in ${CFLAGS}; do 293 for x in ${CFLAGS}; do
208 for y in ${ALLOWED_FLAGS}; do 294 for y in ${ALLOWED_FLAGS}; do
209 flag=${x%%=*} 295 flag=${x%%=*}
210 if [ "${flag%%${y}}" = "" ]; then 296 if [ "${flag%%${y}}" = "" ] ; then
211 NEW_CFLAGS="${NEW_CFLAGS} ${x}" 297 NEW_CFLAGS="${NEW_CFLAGS} ${x}"
212 break 298 break
213 fi 299 fi
214 done 300 done
215 done 301 done
216 302
217 for x in ${CXXFLAGS}; do 303 for x in ${CXXFLAGS}; do
218 for y in ${ALLOWED_FLAGS}; do 304 for y in ${ALLOWED_FLAGS}; do
219 flag=${x%%=*} 305 flag=${x%%=*}
220 if [ "${flag%%${y}}" = "" ]; then 306 if [ "${flag%%${y}}" = "" ] ; then
221 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}" 307 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
222 break 308 break
223 fi 309 fi
224 done 310 done
225 done 311 done
237 export CFLAGS="${NEW_CFLAGS}" 323 export CFLAGS="${NEW_CFLAGS}"
238 export CXXFLAGS="${NEW_CXXFLAGS}" 324 export CXXFLAGS="${NEW_CXXFLAGS}"
239 return 0 325 return 0
240} 326}
241 327
328test-flag-PROG() {
329 local comp=$1
330 local flags="$2"
331
332 [[ -z ${comp} || -z ${flags} ]] && \
333 return 1
334
335 local PROG=$(tc-get${comp})
336 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
337 > /dev/null 2>&1
338}
339
340# @FUNCTION: test-flag-CC
341# @USAGE: <flag>
342# @DESCRIPTION:
343# Returns shell true if <flag> is supported by the C compiler, else returns shell false.
344test-flag-CC() { test-flag-PROG "CC" "$1"; }
345
346# @FUNCTION: test-flag-CXX
347# @USAGE: <flag>
348# @DESCRIPTION:
349# Returns shell true if <flag> is supported by the C++ compiler, else returns shell false.
350test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
351
352test-flags-PROG() {
353 local comp=$1
354 local flags
355 local x
356
357 shift
358
359 [[ -z ${comp} ]] && return 1
360
361 x=""
362 for x in "$@" ; do
363 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
364 done
365
366 echo "${flags}"
367
368 # Just bail if we dont have any flags
369 [[ -n ${flags} ]]
370}
371
372# @FUNCTION: test-flags-CC
373# @USAGE: <flags>
374# @DESCRIPTION:
375# Returns shell true if <flags> are supported by the C compiler, else returns shell false.
376test-flags-CC() { test-flags-PROG "CC" "$@"; }
377
378# @FUNCTION: test-flags-CXX
379# @USAGE: <flags>
380# @DESCRIPTION:
381# Returns shell true if <flags> are supported by the C++ compiler, else returns shell false.
382test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
383
384# @FUNCTION: test-flags
385# @USAGE: <flags>
386# @DESCRIPTION:
387# Short-hand that should hopefully work for both C and C++ compiler, but
388# its really only present due to the append-flags() abomination.
389test-flags() { test-flags-CC "$@"; }
390
391# @FUNCTION: test_flag
392# @DESCRIPTION:
393# DEPRICIATED, use test-flags()
242test_flag() { 394test_flag() {
243 local cc=${CC:-gcc} ; cc=${cc%% *} 395 ewarn "test_flag: deprecated, please use test-flags()!" >&2
244 if ${cc} -S -xc "$@" -o /dev/null /dev/null &>/dev/null; then
245 printf "%s\n" "$*"
246 return 0
247 fi
248 return 1
249}
250 396
397 test-flags-CC "$@"
398}
399
400# @FUNCTION: test_version_info
401# @USAGE: <version>
402# @DESCRIPTION:
403# Returns shell true if the current C compiler version matches <version>, else returns shell false.
404# Accepts shell globs.
251test_version_info() { 405test_version_info() {
252 local cc=${CC:-gcc} ; cc=${cc%% *}
253 if [[ $(${cc} --version 2>&1) == *$1* ]]; then 406 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
254 return 0 407 return 0
255 else 408 else
256 return 1 409 return 1
257 fi 410 fi
258} 411}
259 412
413# @FUNCTION: strip-unsupported-flags
414# @DESCRIPTION:
415# Strip C[XX]FLAGS of any flags not supported by the active toolchain.
260strip-unsupported-flags() { 416strip-unsupported-flags() {
261 local NEW_CFLAGS NEW_CXXFLAGS 417 export CFLAGS=$(test-flags-CC ${CFLAGS})
262 418 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
263 for x in ${CFLAGS} ; do
264 NEW_CFLAGS="${NEW_CFLAGS} `test_flag ${x}`"
265 done
266 for x in ${CXXFLAGS} ; do
267 NEW_CXXFLAGS="${NEW_CXXFLAGS} `test_flag ${x}`"
268 done
269
270 export CFLAGS="${NEW_CFLAGS}"
271 export CXXFLAGS="${NEW_CXXFLAGS}"
272} 419}
273 420
421# @FUNCTION: get-flag
422# @USAGE: <flag>
423# @DESCRIPTION:
424# Find and echo the value for a particular flag. Accepts shell globs.
274get-flag() { 425get-flag() {
275 local f findflag="$1" 426 local f findflag="$1"
276 427
277 # this code looks a little flaky but seems to work for 428 # this code looks a little flaky but seems to work for
278 # everything we want ... 429 # everything we want ...
286 fi 437 fi
287 done 438 done
288 return 1 439 return 1
289} 440}
290 441
442# @FUNCTION: has_hardened
443# @DESCRIPTION:
444# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
291has_hardened() { 445has_hardened() {
446 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
447
292 test_version_info Hardened 448 test_version_info Hardened && return 0
293 return $? 449 # The specs file wont exist unless gcc has GCC_SPECS support
450 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
294} 451}
295 452
453# @FUNCTION: has_pic
454# @DESCRIPTION:
455# DEPRECATED - use gcc-specs-pie from toolchain-funcs
456# indicate whether PIC is set
296has_pic() { 457has_pic() {
297 [ "${CFLAGS/-fPIC}" != "${CFLAGS}" ] && return 0 458 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
298 [ "${CFLAGS/-fpic}" != "${CFLAGS}" ] && return 0
299 test_version_info pie && return 0
300 return 1
301}
302 459
460 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
461 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
462 gcc-specs-pie
463}
464
465# @FUNCTION: has_pie
466# @DESCRIPTION:
467# DEPRECATED - use gcc-specs-pie from toolchain-funcs
468# indicate whether PIE is set
303has_pie() { 469has_pie() {
304 [ "${CFLAGS/-fPIE}" != "${CFLAGS}" ] && return 0 470 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
305 [ "${CFLAGS/-fpie}" != "${CFLAGS}" ] && return 0 471
306 test_version_info pie && return 0 472 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
307 return 1 473 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
474 gcc-specs-pie
308} 475}
309 476
477# @FUNCTION: has_ssp_all
478# @DESCRIPTION:
479# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
480# indicate whether code for SSP is being generated for all functions
481has_ssp_all() {
482 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
483
484 # note; this matches only -fstack-protector-all
485 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
486 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
487 gcc-specs-ssp-all
488}
489
490# @FUNCTION: has_ssp
491# @DESCRIPTION:
492# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
493# indicate whether code for SSP is being generated
310has_ssp() { 494has_ssp() {
495 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
496
497 # note; this matches both -fstack-protector and -fstack-protector-all
311 [ "${CFLAGS/-fstack-protector}" != "${CFLAGS}" ] && return 0 498 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
312 test_version_info ssp && return 0 499 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
313 return 1 500 gcc-specs-ssp
314} 501}
315 502
503# @FUNCTION: has_m64
504# @DESCRIPTION:
505# This doesn't test if the flag is accepted, it tests if the flag actually
506# WORKS. Non-multilib gcc will take both -m32 and -m64. If the flag works
507# return code is 0, else the return code is 1.
316has_m64() { 508has_m64() {
317 # this doesnt test if the flag is accepted, it tests if the flag 509 # this doesnt test if the flag is accepted, it tests if the flag
318 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64! 510 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
319 # please dont replace this function with test_flag in some future 511 # please dont replace this function with test_flag in some future
320 # clean-up! 512 # clean-up!
321 temp=`mktemp` 513
514 local temp="$(emktemp)"
322 echo "int main() { return(0); }" > ${temp}.c 515 echo "int main() { return(0); }" > "${temp}".c
323 ${CC/ .*/} -m64 -o /dev/null ${temp}.c > /dev/null 2>&1 516 MY_CC=$(tc-getCC)
324 ret=$? 517 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
518 local ret=$?
325 rm -f ${temp}.c 519 rm -f "${temp}".c
326 [ "$ret" != "1" ] && return 0 520 [[ ${ret} != 1 ]] && return 0
327 return 1 521 return 1
328} 522}
329 523
524# @FUNCTION: has_m32
525# @DESCRIPTION:
526# This doesn't test if the flag is accepted, it tests if the flag actually
527# WORKS. Non-mulilib gcc will take both -m32 and -64. If the flag works return
528# code is 0, else return code is 1.
330has_m32() { 529has_m32() {
331 # this doesnt test if the flag is accepted, it tests if the flag 530 # this doesnt test if the flag is accepted, it tests if the flag
332 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64! 531 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
333 # please dont replace this function with test_flag in some future 532 # please dont replace this function with test_flag in some future
334 # clean-up! 533 # clean-up!
335 temp=`mktemp` 534
535 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
536
537 local temp=$(emktemp)
336 echo "int main() { return(0); }" > ${temp}.c 538 echo "int main() { return(0); }" > "${temp}".c
337 ${CC/ .*/} -m32 -o /dev/null ${temp}.c > /dev/null 2>&1 539 MY_CC=$(tc-getCC)
338 ret=$? 540 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
541 local ret=$?
339 rm -f ${temp}.c 542 rm -f "${temp}".c
340 [ "$ret" != "1" ] && return 0 543 [[ ${ret} != 1 ]] && return 0
341 return 1 544 return 1
342} 545}
343 546
547# @FUNCTION: replace-sparc64-flags
548# @DESCRIPTION:
549# Sets mcpu to v8 and uses the original value as mtune if none specified.
344replace-sparc64-flags() { 550replace-sparc64-flags() {
345 local SPARC64_CPUS="ultrasparc v9" 551 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
346 552
347 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then 553 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
348 for x in ${SPARC64_CPUS}; do 554 for x in ${SPARC64_CPUS}; do
349 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}" 555 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
350 done 556 done
351 else 557 else
352 for x in ${SPARC64_CPUS}; do 558 for x in ${SPARC64_CPUS}; do
353 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 559 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
354 done 560 done
355 fi 561 fi
356 562
357 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then 563 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
358 for x in ${SPARC64_CPUS}; do 564 for x in ${SPARC64_CPUS}; do
359 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}" 565 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
360 done 566 done
361 else 567 else
362 for x in ${SPARC64_CPUS}; do 568 for x in ${SPARC64_CPUS}; do
363 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 569 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
364 done 570 done
365 fi 571 fi
366 572
367 export CFLAGS CXXFLAGS 573 export CFLAGS CXXFLAGS
368} 574}
369 575
576# @FUNCTION: append-ldflags
577# @USAGE: <flags>
578# @DESCRIPTION:
579# Add extra <flags> to the current LDFLAGS.
370append-ldflags() { 580append-ldflags() {
581 [[ -z $* ]] && return 0
371 export LDFLAGS="${LDFLAGS} $*" 582 export LDFLAGS="${LDFLAGS} $*"
372 return 0 583 return 0
373} 584}
374 585
586# @FUNCTION: filter-ldflags
587# @USAGE: <flags>
588# @DESCRIPTION:
589# Remove particular <flags> from LDFLAGS. Accepts shell globs.
375filter-ldflags() { 590filter-ldflags() {
376 local x 591 _filter-var LDFLAGS "$@"
592 return 0
593}
377 594
378 # we do this fancy spacing stuff so as to not filter 595# @FUNCTION: raw-ldflags
379 # out part of a flag ... we want flag atoms ! :D 596# @USAGE: <flags>
380 LDFLAGS=" ${LDFLAGS} " 597# @DESCRIPTION:
598# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
599# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
600# to gcc where it needs the '-Wl,'.
601raw-ldflags() {
602 local x input="$@"
603 [[ -z ${input} ]] && input=${LDFLAGS}
604 set --
381 for x in "$@" ; do 605 for x in ${input} ; do
382 LDFLAGS="${LDFLAGS// ${x} / }" 606 x=${x#-Wl,}
607 set -- "$@" ${x//,/ }
383 done 608 done
384 LDFLAGS="${LDFLAGS:1:${#LDFLAGS}-2}" 609 echo "$@"
385 export LDFLAGS
386 return 0
387} 610}
388 611
389etexec-flags() { 612# @FUNCTION: bindnow-flags
390 # if you're not using a hardened compiler you wont need this 613# @RETURN: Returns the flags to enable "now" binding in the current selected linker.
391 # PIC/no-pic kludge in the first place. 614# @DESCRIPTION:
392 has_hardened || return 0 615# DEPRECATED - Gets the flags needed for "NOW" binding
616bindnow-flags() {
617 ewarn "QA: stop using the bindnow-flags function ... simply drop it from your ebuild"
393 618
394 if has_pie || has_pic; then 619 case $($(tc-getLD) -v 2>&1 </dev/null) in
395 [ -z "`is-flag -fno-pic`" ] && 620 *GNU* | *'with BFD'*) # GNU ld
396 export CFLAGS="${CFLAGS} `test_flag -fno-pic`" 621 echo "-Wl,-z,now" ;;
397 [ -z "`is-flag -nopie`" ] && 622 *Apple*) # Darwin ld
398 export CFLAGS="${CFLAGS} `test_flag -nopie`" 623 echo "-bind_at_load" ;;
399 fi 624 *)
400 return 0 625 # Some linkers just recognize -V instead of -v
626 case $($(tc-getLD) -V 2>&1 </dev/null) in
627 *Solaris*) # Solaris accept almost the same GNU options
628 echo "-Wl,-z,now" ;;
629 esac
630 ;;
631 esac
401} 632}
402 633
403fstack-flags() { 634
404 if has_ssp; then 635# Some tests for when we screw with things and want to make
405 [ -z "`is-flag -fno-stack-protector`" ] && 636# sure we didn't break anything
406 export CFLAGS="${CFLAGS} `test_flag -fno-stack-protector`" 637#TESTS() {
407 fi 638# CFLAGS="-a -b -c=1"
408 return 0 639# CXXFLAGS="-x -y -z=2"
409} 640# LDFLAGS="-l -m -n=3"
641#
642# die() { exit 1; }
643# (is-flag 1 2 3) && die
644# (is-ldflag 1 2 3) && die
645#
646# is-flagq -l && die
647# is-ldflagq -a && die
648# is-flagq -a || die
649# is-flagq -x || die
650# is-ldflagq -n=* || die
651# is-ldflagq -n && die
652#
653# strip-unsupported-flags
654# [[ ${CFLAGS} == "-c=1" ]] || die
655# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
656#
657# echo "All tests pass"
658#}
659#TESTS

Legend:
Removed from v.1.62  
changed lines
  Added in v.1.121

  ViewVC Help
Powered by ViewVC 1.1.20